#!/usr/bin/python3
import random
import sys

# Very tall rectangle with several long lines. 

n, s = map(int, sys.argv[1:3])
random.seed(s)

m = 250000//n

perm = list(range(1,n+1))
random.shuffle(perm)

amoves = []
bmoves = []
for i in range(n//2):
    amoves += [perm[2*i]] * m
    bmoves += [perm[2*i+1]] * m

if n%2 == 1:
    amoves += [perm[-1]] * ((m+1)//2)
    bmoves += [perm[-1]] * (m//2)

random.shuffle(amoves)
random.shuffle(bmoves)

moves = [x for pr in zip(amoves,bmoves) for x in pr]
if len(amoves) > len(bmoves): moves.append(amoves[-1])

print(f'{m} {n} {m-random.randint(0,10)}')
print(' '.join(map(str, moves)))
