#include <bits/stdc++.h>

using namespace std;

const int oo = 0x3f3f3f3f;
const double eps = 1e-9;
const double PI = 2.0 * acos(0.0);


typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<string> vs;

#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define FOR(i,a,b) for (int i = (a); i < (b); i++)
#define FORS(i,a,b,s) for (int i = (a); i < (b); i=i+(s))
#define FORD(i,a,b) for (int i = int(b)-1; i >= (a); i--)
#define FORIT(i,c) for (__typeof__((c).begin()) i = (c).begin(); i != (c).end(); i++)


int main(){
	int N,M; cin >> N >> M;
	
	vector<pii> glades(N);
	vector<pair<pii,int>> hills(M);

	FOR(i,0,N) cin >> glades[i].first >> glades[i].second;
	FOR(i,0,M) cin >> hills[i].first.first >> hills[i].first.second >> hills[i].second;


	set<pii> s_glades;
	for (auto g : glades) s_glades.insert(g);
	if (s_glades.size() != glades.size()) exit(43); // duplicate glade




	FOR(i,0,M){
		auto h = hills[i];
		int gI = 0;
		for (auto g : glades){
			ll dx = h.first.first - g.first;
			ll dy = h.first.second - g.second;
			
		
			if (dx*dx + dy*dy <= h.second * h.second){
			   	cout << "Hill " << i << "(" << h.first.first << "," << h.first.second << ") inside of glade " << gI << " (" << g.first << "," << g.second << ")" << endl;
				exit(43); // point to close to circle ...
			}
			gI++;
		}


		FOR(j,0,M){
			if (i == j) continue;
			auto h2 = hills[j];

			ll dx = h.first.first  - h2.first.first;
			ll dy = h.first.second - h2.first.second;
			
			if (dx*dx + dy*dy <= (h.second + h2.second) * (h.second + h2.second)) exit(43); // point to close to circle ...
			
		}
	}

	exit(42);
}
