#!/bin/python3
import sys

# quasi linear (only one set with all curches that is queried for log(n). can be optimized with hashing)
# This is still a slow submission, because the counting lists are are slow to be created.. python

MAX = 1000000

def remap(s):
	return int(s) + MAX

m, c = map(int, input().split(" "))
ms = [tuple(map(remap, input().split(" "))) for _ in range(m)]
cs = [tuple(map(remap, input().split(" "))) for _ in range(c)]

monsX = [0] * (MAX * 2 + 10)
monsY = [0] * (MAX * 2 + 10)

for x, y in ms:
	monsX[x] += 1
	monsY[y] += 1

bestXs = []
bestYs = []

csX = [0] * (MAX * 2 + 10)
csY = [0] * (MAX * 2 + 10)
curBestX = 0
curBestY = 0

allcs = set()

for x, y in cs:
	# already magic
	if monsX[x] >= 2 or monsY[y] >= 2:
		continue
	allcs.add((x, y))
	if monsX[x] == 1:
		csX[x] += 1
		if csX[x] == curBestX:
			bestXs += [x]
		elif csX[x] > curBestX:
			bestXs = [x]
			curBestX = csX[x]
	if monsY[y] == 1:
		csY[y] += 1
		if csY[y] == curBestY:
			bestYs += [y]
		elif csY[y] > curBestY:
			bestYs = [y]
			curBestY = csY[y]

def get(x, y):
#	if (x, y) in ms:
#		return None
	g = gainX[x] + gainY[y]
	if (x, y) in cs and monsX[x] == 1 and monsY[y] == 1:
		g -= 1
	return g

def found(x, y, res):
	print(x-MAX, y-MAX)
	print(res)
	sys.exit(0)

if curBestX == 0 and curBestY == 0:
	print(0, 0)
	print(0)
elif curBestX == 0:
	print(0, bestYs[0]-MAX)
	print(curBestY)
elif curBestY == 0:
	print(bestXs[0]-MAX, 0)
	print(curBestX)
else:
	# try all best combinations
	# there are at most c non-perfect (every non-perfect has a church at its intersection)
	for x in bestXs:
		for y in bestYs:
			if not (x, y) in allcs:
				found(x, y, curBestX + curBestY)
	found(bestXs[0], bestYs[0], curBestX + curBestY - 1)
