#include <bits/stdc++.h>
using namespace std;

int main() {
	int n, l;
	cin >> n >> l;
	vector<string> ids(n);
	for(string& id : ids) {
		cin >> id;
	}

	vector<map<int,int>> comparis(n-1);
	for(int line = 0; line < comparis.size(); line++) {
		for(int letter = 0; letter < l; letter++) {
			int compari = ids[line+1][letter] - ids[line][letter];
			if(compari) {
				comparis[line][letter] = compari;
			}
		}
		comparis[line][l] = INT_MIN;
	}

	pair<int,pair<int,int>> bestres = {INT_MAX,{0,0}};
	for(int startcol = 1; startcol < l; startcol++) {
		int endcol = startcol;
		bool works = true;
		for(int line = 0; line < comparis.size(); line++) {
			auto it = comparis[line].lower_bound(startcol);
			if(it->second < 0) {
				works = false;
				break;
			}
			endcol = max(endcol, it->first);
		}
		if(works) {
			bestres = min(bestres, {endcol-startcol, {startcol, endcol}});
		}
	}

	cout << bestres.second.first+1 << ' ' << bestres.second.second+1 << endl;
}
