#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int MAX_N = 505;
const int MAX_L = 20005;
vector<string> words(MAX_N);
vector<vector<int>> pref(MAX_N,vector<int>(MAX_L,MAX_L)); 
vector<int> maxInCol(MAX_L,-1);

int main()
{
	int n,l; cin >> n >> l;
	for (int i = 0; i < n; ++i)
		cin >> words[i];
	for (int i = 0; i < n-1; ++i)
	{
		string &x = words[i];
		string &y = words[i+1];
		vector<int> &z = pref[i];
		for (int j = l-1; j >= 0; --j)
		{
			if (x[j] < y[j])
				z[j] = 1;
			else if (x[j] == y[j] && j != l-1 && z[j+1] != MAX_L)
				z[j] = z[j+1] + 1;
		}
	}
	for (int i = 0; i < l; ++i)
		for (int j = 0; j < n-1; ++j)
			maxInCol[i] = max(maxInCol[i],pref[j][i]);
	int pos = min_element(maxInCol.begin(),maxInCol.begin()+l) - maxInCol.begin();
	cout << pos+1 << " " << pos+maxInCol[pos] << endl;
}
