#include <iostream>
#include <vector>
#include <string>
using namespace std;

int check(vector<string> &words, int n, int l, int len)
{
	for (int i = 0; i < l - len + 1; ++i)
	{
		bool possible = true;
		for (int k = 0; k < n-1; ++k)
		{
			if (words[k].compare(i,len,words[k+1],i,len) >= 0)
			{
				possible = false;
				break;
			}
		}
		if (possible) return i;
	}
	return -1;
}

int main()
{
	int n,l; cin >> n >> l;
	vector<string> words;
	for (int i = 0; i < n; ++i)
	{
		string s; cin >> s;
		words.push_back(s);
	}
	int low = 0; int high = l;
	int pos = -1;
	while (high - low > 1)
	{
		int mid = (low + high) / 2;
		int c = check(words,n,l,mid);
		if (c == -1) 
			low = mid;
		else
			high = mid, pos = c;
	}
	cout << pos + 1 << " " << pos + high << endl;
}
