#include <cstring>
#include <iostream>
#include <vector>
using namespace std;

const int di[] = {-1,-1,-1,0,1,1,1,0};
const int dj[] = {-1,0,1,-1,1,0,-1,1};

int main() {
	int h, w, k;
	cin >> h >> w >> k;
	
	vector<int> pos(w+2);
	vector<vector<int>> a(h+2, vector<int>(w+2,-1));

	for (int r = 1; r <= h*w; r++) {
		int j; cin >> j;
		int i = ++pos[j];
		a[i][j] = r%2;

		for (int dir = 0; dir < 4; dir++) {
			int len = -1;
			for (int ci = i, cj = j; a[ci][cj] == a[i][j]; ci += di[dir], cj += dj[dir]) {
				len++;
			}
			for (int ci = i, cj = j; a[ci][cj] == a[i][j]; ci += di[dir+4], cj += dj[dir+4]) {
				len++;
			}
			if (len >= k) {
				cout << "BA"[r%2] << " " << r << endl;
				return 0;
			}
		}
	}
	cout << "D" << endl;
}
