#include <bits/stdc++.h>
using namespace std;

int main() {
	int h, w, n;
	cin >> h >> w >> n;

	auto ok = [&](int x, int y) {
		return 0 <= x && x < h && 0 <= y && y < w;
	};
	
	vector<string> a(h, string(w,'.'));
	vector<int> next(w, h-1);
	
	int col[h][w], dp[h][w][8];
	memset(col, -1, sizeof col);
	memset(dp, 0, sizeof dp);
	vector<pair<int,int>> dir = {{-1,-1},{-1,0},{-1,1},{0,-1},{0,1},{1,-1},{1,0},{1,1}};

	for (int i = 0; i < h*w; i++) {
		int y; cin >> y;
		int x = next[--y]--;

		col[x][y] = i%2;
		for (int k = 0; k < 8; k++) {
			auto [dx,dy] = dir[k];
			dp[x][y][k] = 1;
			if (ok(x+dx,y+dy) && col[x+dx][y+dy] == col[x][y]) {
				dp[x][y][k] += dp[x+dx][y+dy][k];
			}
			if (dp[x][y][k] >= n) {
				cout << "AB"[i%2] << " " << i+1 << endl;
				return 0;
			}
		}
	}
	cout << "D" << endl;
}
